editor_status = '';
tags = {};
(function($){
  $(window).load(function() {
    if(!isTinyMCE()) {
      setTimeout(setupPostEditor, 50);
    }
    else {
      editor_status = 'tmce';
    }
  })
  function _datetime() {
    var now = new Date(), zeroise;
    
    zeroise = function(number) {
      var str = number.toString();
      if(str.length < 2) {
        str = "0" + str;
      }
      return str;
    }
    
    return now.getUTCFullYear() + '-' + zeroise(now.getUTCMonth() + 1) + '-' + zeroise(now.getUTCDate()) + 'T' + zeroise(now.getUTCHours()) + ':' + zeroise(now.getUTCMinutes()) + ':' + zeroise(now.getUTCSeconds()) + '+00:00';
  }
  function insertOpenCloseTag(tag, title, beginningTag, endTag) {
    
    var selection = editor.getSelection();
    if(selection != '') {
      editor.replaceSelection(beginningTag + selection + endTag, 'end');
      editor.focus();
    }
    else {
      if(!tags[tag]) {
        tags[tag] = {'lastTag': 0};
      }
      if(beginningTag == '') {
        editor.replaceSelection(endTag, 'end');
        $('#wpe_qt_content_' + tag).val(title);
        editor.focus();
      }
      else if(endTag == '') {
        editor.replaceSelection(beginningTag, 'end');
        editor.focus();
      }
      else if(!tags[tag].lastTag || tags[tag].lastTag == 0) {
        editor.replaceSelection(beginningTag, 'end');
        $('#wpe_qt_content_' + tag).val('/' + title);
        editor.focus();
        tags[tag].lastTag = 1;
      }
      else if(tags[tag].lastTag == 1) {
        editor.replaceSelection(endTag, 'end');
        $('#wpe_qt_content_' + tag).val(title);
        editor.focus();
        tags[tag].lastTag = 0;
      }
    }
  }
  function openLinkDialog() {
    if(typeof(wpLink) != 'undefined') {
      wpLink.open();
      return;
    }
  }
  function insertLinkTag(link, title, blank) {
    var selection = editor.getSelection();
    var newLink = link != '' ? link : '';
    var newTitle = title != '' ? '" title="' + title : '';
    var newBlank = blank == true ? '" target="_blank' : ''
    var combinedTags = newLink + newTitle + newBlank;
    if(selection != '') {
      editor.replaceSelection('<a href="' + combinedTags + '">' + selection + '</a>', 'end');
      tags.link = {'lastTag': 0};
    }
    else {
      editor.replaceSelection('<a href="' + combinedTags + '">', 'end');
      $('#wpe_qt_content_link').val('/link');
      tags.link = {'lastTag': 1};
    }
    editor.focus();
  }
  function insertImgTag() {
    var src = prompt(WPEPosts.enterImgUrl, 'http://'), alt;
    if(src) {
      alt = prompt(WPEPosts.enterImgDescription, '');
      editor.replaceSelection('<img src="' + src + '" alt="' + alt + '" />', 'end');
      editor.focus();
    }
  }
  function lookupWord() {
    var word = editor.getSelection();
    if(word == '') {
      word = prompt(WPEPosts.wordLookup, '');
    }
    if(word !== null && /^\w[\w ]*$/.test(word)) {
      window.open('http://www.answers.com/' + encodeURIComponent(word));
    }
  }
  $(document).ready(function(){
    $('#ed_toolbar').hide();
    $('#wpe_qt_content_strong').live("click", function() {
      insertOpenCloseTag('strong', 'b', '<strong>', '</strong>');
    })
    $('#wpe_qt_content_em').live("click", function() {
      insertOpenCloseTag('em', 'i', '<em>', '</em>');
    })
    $('#wpe_qt_content_link').live("click", function() {
      if(!tags.link || tags.link.lastTag == 0) {
        openLinkDialog();
      }
      else {
        insertOpenCloseTag('link', 'link', '', '</a>');
        tags.link = {'lastTag': 0};
      }
    })
    $('#wpe_qt_content_block').live("click", function() {
      insertOpenCloseTag('block', 'b-quote', '\n\n<blockquote>', '</blockquote>\n\n');
    })
    $('#wpe_qt_content_block').live("click", function() {
      insertOpenCloseTag('block', 'b-quote', '\n\n<blockquote>', '</blockquote>\n\n');
    })
    $('#wpe_qt_content_del').live("click", function() {
      insertOpenCloseTag('del', 'del', '<del datetime="' + _datetime() + '">', '</del>');
    })
    $('#wpe_qt_content_ins').live("click", function() {
      insertOpenCloseTag('ins', 'ins', '<ins datetime="' + _datetime() + '">', '</ins>');
    })
    $('#wpe_qt_content_img').live("click", function() {
      insertImgTag();
    })
    $('#wpe_qt_content_ul').live("click", function() {
      insertOpenCloseTag('ul', 'ul', '<ul>\n', '</ul>\n\n');
    })
    $('#wpe_qt_content_ol').live("click", function() {
      insertOpenCloseTag('ol', 'ol', '<ol>\n', '</ol>\n\n');
    })
    $('#wpe_qt_content_li').live("click", function() {
      insertOpenCloseTag('li', 'li', '\t<li>', '</li>\n');
    })
    $('#wpe_qt_content_code').live("click", function() {
      insertOpenCloseTag('code', 'code', '<code>', '</code>');
    })
    $('#wpe_qt_content_more').live("click", function() {
      insertOpenCloseTag('more', 'more', '', '<!--more-->');
    })
    $('#wpe_qt_content_page').live("click", function() {
      insertOpenCloseTag('page', 'page', '', '<!--nextpage-->');
    })
    $('#wpe_qt_content_lookup').live("click", function() {
      lookupWord();
    })
    $('#wpe_qt_content_fullscreen').live("click", function() {
      toggleFullscreenEditing();
      editor.focus();
    })
    $('#wp-link-submit').live("click", function() {
      var link = $('#url-field').val();
      var title = $('#link-title-field').val();
      var blank = false;
      if($('#link-target-checkbox').is(':checked')) {
        blank = true;
      }
      insertLinkTag(link, title, blank);
      return false;
    })
    $('#content-tmce').click(function() {
      if(editor_status != 'tmce') {
        editor.toTextArea();
        switchEditors.switchto(this);
        editor_status = 'tmce';
      }
    })
    $('#content').keyup(function() {
      console.log('yep, keyup')
      editor.save();
    })
    $('#content-html').click(function() {
      if(editor_status != 'html') {
        postCodeMirror('content');
        editor_status = 'html';
      }
      else {
        editor.toTextArea();
        postCodeMirror('content');
        return false;
      }
    })
    $('#publish').click(function() {
      editor.save();
    })
  })
  function setupPostEditor() {
    if(!isTinyMCE()) {
      if($('#content').is(':visible')) {
        if(!$('#content_parent').is(':visible')) {
          postCodeMirror('content');
          editor_status = 'html';
        }
      }
    }
  }
  function isTinyMCE() {
    is_tinyMCE_active = true;
    if (typeof(tinyMCE) != "undefined") {
      if (tinyMCE.activeEditor == null || tinyMCE.activeEditor.isHidden() != false) {
        is_tinyMCE_active = false;
      }
    }
    return is_tinyMCE_active;
  }
  function postCodeMirror(element) {
    var activeLine = WPEPosts.activeLine;
    editor = CodeMirror.fromTextArea(document.getElementById(element), {
      mode: WPEPosts.mode,
      theme: WPEPosts.theme,
      lineNumbers: WPEPosts.lineNumbers,
      lineWrapping: WPEPosts.lineWrapping,
      onCursorActivity: function() {
        editor.setLineClass(hlLine, null);
        hlLine = editor.setLineClass(editor.getCursor().line, activeLine);
      },
      onChange: function() {
        changeTrue();
      },
      onKeyEvent: function(editor, event) {
        if(typeof(wpWordCount) != 'undefined') {
          editor.save();
          last = 0, co = $('#content');
          $(document).triggerHandler('wpcountwords', [ co.val() ]);
          
          co.keyup(function(e) {
            var k = event.keyCode || event.charCode;
            
            if(k == last) {
              return true;
            }
            if(13 == k || 8 == last || 46 == last) {
              $(document).triggerHandler('wpcountwords', [ co.val() ]);
            }
            last = k;
            return true;
          });
        }
        
      },
      extraKeys: {
        'F11': toggleFullscreenEditing, 
        'Esc': toggleFullscreenEditing
      }
    });
    var hlLine = editor.setLineClass(0, activeLine);
    if(!$('.CodeMirror .quicktags-toolbar').length) {
      $('.CodeMirror').prepend('<div class="quicktags-toolbar">' + 
        '<input type="button" id="wpe_qt_content_strong" class="wpe_ed_button" title="" value="b">' + 
        '<input type="button" id="wpe_qt_content_em" class="wpe_ed_button" title="" value="i">' + 
        '<input type="button" id="wpe_qt_content_link" class="wpe_ed_button" title="" value="link">' + 
        '<input type="button" id="wpe_qt_content_block" class="ed_button" title="" value="b-quote">' + 
        '<input type="button" id="wpe_qt_content_del" class="ed_button" title="" value="del">' + 
        '<input type="button" id="wpe_qt_content_ins" class="ed_button" title="" value="ins">' + 
        '<input type="button" id="wpe_qt_content_img" class="ed_button" title="" value="img">' + 
        '<input type="button" id="wpe_qt_content_ul" class="ed_button" title="" value="ul">' + 
        '<input type="button" id="wpe_qt_content_ol" class="ed_button" title="" value="ol">' + 
        '<input type="button" id="wpe_qt_content_li" class="ed_button" title="" value="li">' + 
        '<input type="button" id="wpe_qt_content_code" class="ed_button" title="" value="code">' + 
        '<input type="button" id="wpe_qt_content_more" class="ed_button" title="" value="more">' + 
        '<input type="button" id="wpe_qt_content_page" class="ed_button" title="" value="page">' + 
        '<input type="button" id="wpe_qt_content_lookup" class="ed_button" title="" value="lookup">' + 
        '<input type="button" id="wpe_qt_content_fullscreen" class="ed_button" title="" value="fullscreen">' + 
        '</div>'
      ).height($('.CodeMirror').height() + 33);
    }
  }
})(jQuery);